# Load utility functions from the "utils.R" file
source("utils.R")

# Set parameters for data generation
n = 100
d = 100
K = 6
rho = 0

# Generate synthetic data with or without contamination using gen_K_new function
X = gen_K_new(n = n, d = d, K = K, pcont = rho, df = 2, cont = "Student", min = -10, max = 10, radius = 10)
# Extract information from the generated data
I = X$I
cen = X$cen
Tclassif = X$classif
X = X$X

# Perform K-medians clustering and our Slope method to find the number of clusters
a = Kmedians(X, nclust = 1:40, method = 'Offline')
# Display the selected number of clusters 
a$Ksel

# Plot various plots for K-medians clustering
Kplot(a,propplot=0.95,graph=c('Two_Dim','Capushe','Profiles','SE','Criterion'),
      bestresult=TRUE,Ksel=FALSE,bycluster=TRUE)



# Perform K-means clustering and our Slope method to find the number of clusters using K-means clustering
b = Kmeans(X, nclust = 1:40, ninit = 10)
b$Ksel
Kplot(b,propplot=0.99,graph=c('Two_Dim','Capushe','Profiles','SE','Criterion'),
      bestresult=TRUE,Ksel=FALSE,bycluster=TRUE)









